import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import multilizer.*;

public class Frame1 extends JFrame
{
  //Construct the frame

  javax.swing.JLabel jLabel1 = new javax.swing.JLabel();
  BorderLayout borderLayout1 = new BorderLayout();
  javax.swing.JButton jButton1 = new javax.swing.JButton();
  javax.swing.JRadioButton jRadioButton1 = new javax.swing.JRadioButton();
  javax.swing.JCheckBox jCheckBox1 = new javax.swing.JCheckBox();
  multilizer.BinaryDictionary binaryDictionary1 = new multilizer.BinaryDictionary();
  multilizer.Translator translator1 = new multilizer.Translator();
  multilizer.SwingModule swingModule1 = new multilizer.SwingModule();

  public Frame1()
  {
    enableEvents(AWTEvent.WINDOW_EVENT_MASK);
    try
    {
      jbInit();

      // Translate the frame
      translator1.translate();
    }
    catch (Exception e)
    {
      e.printStackTrace();
    }
  }

  //Component initialization

  private void jbInit() throws Exception
  {
    this.getContentPane().setLayout(borderLayout1);
    this.setSize(new Dimension(400, 300));
    jLabel1.setText("This is a sample text");
    jButton1.setText("button");
    jButton1.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(ActionEvent e)
      {
        jButton1_actionPerformed(e);
      }
    });
    jRadioButton1.setText("radio button");
    jCheckBox1.setText("check box");
    binaryDictionary1.setFileName("dictionary.mld");
    translator1.setHost(this);
    translator1.setTargets("+*.text;+*.label;+*.title;+*.items;+*.toolTipText");
    this.setTitle("Frame Title");
    this.getContentPane().add(jLabel1, BorderLayout.NORTH);
    this.getContentPane().add(jButton1, BorderLayout.SOUTH);
    this.getContentPane().add(jRadioButton1, BorderLayout.WEST);
    this.getContentPane().add(jCheckBox1, BorderLayout.EAST);
  }

  //Overriden so we can exit on System Close

  protected void processWindowEvent(WindowEvent e)
  {
    super.processWindowEvent(e);
    if (e.getID() == WindowEvent.WINDOW_CLOSING)
    {
      System.exit(0);
    }
  }

  void jButton1_actionPerformed(ActionEvent e)
  {
    int language = SelectLanguageDialog.select(
      this,
      new Translator(binaryDictionary1),
      false);

    if (language >= 0)
      binaryDictionary1.setLanguage(language);
  }
}

