import java.awt.*;
import java.awt.event.*;
import java.util.*;
import java.text.*;
import multilizer.*;

public class MainFrame extends Frame
{
  MenuBar menuBar1 = new MenuBar();
  Menu fileMenu = new Menu();
  MenuItem exitMenuItem = new MenuItem();
  Menu helpMenu = new Menu();
  MenuItem aboutMenuItem = new MenuItem();
  GridLayout gridLayout1 = new GridLayout();
  Panel panel1 = new Panel();
  TextField textField = new TextField();
  FlowLayout flowLayout1 = new FlowLayout();
  Label unitLabel = new Label();
  Button calculateButton = new Button();
  Panel panel2 = new Panel();
  Panel panel3 = new Panel();
  Panel panel4 = new Panel();
  Panel panel5 = new Panel();
  Label fineLabel = new Label();
  Label label4 = new Label();
  Label label5 = new Label();
  Label dateLabel = new Label();
  Label label7 = new Label();
  Label localeLabel = new Label();
  Label label9 = new Label();
  Label languageLabel = new Label();
  FlowLayout flowLayout2 = new FlowLayout();
  FlowLayout flowLayout3 = new FlowLayout();
  FlowLayout flowLayout4 = new FlowLayout();
  FlowLayout flowLayout5 = new FlowLayout();
  Panel panel6 = new Panel();
  Label label1 = new Label();
  FlowLayout flowLayout6 = new FlowLayout();
  TextDictionary dictionary1 = new TextDictionary();
  Translator translator1 = new Translator();
  MenuItem languageMenuItem = new MenuItem();
  MenuItem localeMenuItem = new MenuItem();
  MenuItem subLanguageMenuItem = new MenuItem();
  MenuItem menuItem1 = new MenuItem();

  public MainFrame()
  {
    enableEvents(AWTEvent.WINDOW_EVENT_MASK);
    try
    {
      jbInit();
      translator1.translate();
    }
    catch (Exception e)
    {
      e.printStackTrace();
    }
  }

  // Component initialization

  private void jbInit() throws Exception
  {
    this.setBackground(SystemColor.control);
    this.setSize(new Dimension(321, 217));
    this.setLayout(gridLayout1);
    this.setTitle("Driving Time Calculator");
    fileMenu.setLabel("File");
    exitMenuItem.setLabel("Exit");
    exitMenuItem.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(ActionEvent e)
      {
        exitMenuItem_actionPerformed(e);
      }
    });
    helpMenu.setLabel("Help");
    aboutMenuItem.setLabel("About...");
    aboutMenuItem.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(ActionEvent e)
      {
        aboutMenuItem_actionPerformed(e);
      }
    });
    gridLayout1.setRows(6);
    gridLayout1.setColumns(1);
    textField.setColumns(10);
    panel1.setLayout(flowLayout1);
    flowLayout1.setAlignment(0);
    unitLabel.setText("in kilometres");
    calculateButton.setLabel("Calculate");
    calculateButton.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(ActionEvent e)
      {
        calculateButton_actionPerformed(e);
      }
    });
    panel5.setLayout(flowLayout5);
    panel4.setLayout(flowLayout4);
    panel3.setLayout(flowLayout3);
    panel2.setLayout(flowLayout2);
    fineLabel.setText("dummy");
    label4.setText("Speeding fine:");
    label5.setText("Date and time:");
    dateLabel.setText("dummy");
    label7.setText("Current locale:");
    localeLabel.setText("dummy");
    label9.setText("User interface language:");
    languageLabel.setText("English");
    flowLayout2.setAlignment(0);
    flowLayout3.setAlignment(0);
    flowLayout4.setAlignment(0);
    flowLayout5.setAlignment(0);
    panel6.setLayout(flowLayout6);
    label1.setText("Give the driving distance");
    flowLayout6.setAlignment(0);
    dictionary1.setTranslationFileName("dictionary.translations");
    dictionary1.setFileName("dictionary.languages");
    translator1.setHost(this);
    translator1.setTargets("*.text;*.label;*.title;*.items;*.toolTipText");
    translator1.addLanguageChangeListener(new multilizer.DictionaryListener()
    {
      public void languageChanged(DictionaryEventObject e)
      {
        translator1_languageChanged(e);
      }
    });
    languageMenuItem.setLabel("Language...");
    localeMenuItem.setLabel("Locale...");
    menuItem1.setLabel("-");
    subLanguageMenuItem.setLabel("Sublanguage...");
    subLanguageMenuItem.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(ActionEvent e)
      {
        subLanguageMenuItem_actionPerformed(e);
      }
    });
    languageMenuItem.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(ActionEvent e)
      {
        languageMenuItem_actionPerformed(e);
      }
    });
    localeMenuItem.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(ActionEvent e)
      {
        localeMenuItem_actionPerformed(e);
      }
    });
    this.setMenuBar(menuBar1);
    menuBar1.add(fileMenu);
    menuBar1.add(helpMenu);
    fileMenu.add(languageMenuItem);
    fileMenu.add(localeMenuItem);
    fileMenu.add(subLanguageMenuItem);
    fileMenu.add(menuItem1);
    fileMenu.add(exitMenuItem);
    helpMenu.add(aboutMenuItem);
    this.add(panel6, null);
    panel6.add(label1, null);
    this.add(panel1, null);
    panel1.add(textField, null);
    panel1.add(unitLabel, null);
    panel1.add(calculateButton, null);
    this.add(panel2, null);
    panel2.add(label4, null);
    panel2.add(fineLabel, null);
    this.add(panel3, null);
    panel3.add(label5, null);
    panel3.add(dateLabel, null);
    this.add(panel4, null);
    panel4.add(label7, null);
    panel4.add(localeLabel, null);
    this.add(panel5, null);
    panel5.add(label9, null);
    panel5.add(languageLabel, null);
  }

  private void exit()
  {
    System.exit(0);
  }

  protected void processWindowEvent(WindowEvent e)
  {
    super.processWindowEvent(e);
    if (e.getID() == WindowEvent.WINDOW_CLOSING)
      exit();
  }

  void calculateButton_actionPerformed(ActionEvent e)
  {
    int distance;

    try
    {
      distance = Integer.valueOf(textField.getText().trim()).intValue();
      if (distance < 0)
        throw new NumberFormatException();

      // If the current locale uses US measurement system instead of metric
      // converts the give distance (in miles) to kilometers

      if (Utils.getMeasurementSystem(dictionary1.getActiveLocale()) == Utils.US_MEASUREMENT)
        distance = (int)Utils.MILE_IN_METERS*distance/1000;

      String[] params =
      {
        new Integer(distance/100).toString(),
        new Integer((int)(60*(distance%100)/100)).toString()
      };

      multilizer.MessageDialog.messageBox(
        this,
        "Driving Time", //ivlm
        Utils.formatMessage(
          "The avarage driving time is {0} hours and {1} minutes", //ivlm
          params,
          translator1),
        MessageDialog.OK,
        translator1);
    }
    catch (NumberFormatException ex)
    {
      String[] params = { textField.getText() };

      multilizer.MessageDialog.messageBox(
        this,
        "Invalid value", //ivlm
        Utils.formatMessage(
          "\"{0}\" in not a valid distance", //ivlm
          params,
          translator1),
        MessageDialog.OK,
        translator1);
      textField.requestFocus();
    }
  }

  void exitMenuItem_actionPerformed(ActionEvent e)
  {
    exit();
  }

  void aboutMenuItem_actionPerformed(ActionEvent e)
  {
    multilizer.MessageDialog.messageBox(
      this,
      "About DCALC", //ivlm
      "DCALC calculates the driving time.", //ivlm
      MessageDialog.OK,
      translator1);
  }

  void languageMenuItem_actionPerformed(ActionEvent e)
  {
    SelectLanguageDialog dialog = new SelectLanguageDialog(
      this,
      new Translator(dictionary1),
      false);

    if (dialog.showModal())
    {
      dictionary1.setBinding(multilizer.Dictionary.BIND_LOCALE_TO_LANGUAGE);
      dictionary1.setLanguage(dialog.getLanguage());
    }
  }

  void localeMenuItem_actionPerformed(ActionEvent e)
  {
    SelectLocaleDialog dialog = new SelectLocaleDialog(
      this,
      new Translator(dictionary1),
      false);

    if (dialog.showModal())
    {
      dictionary1.setBinding(multilizer.Dictionary.BIND_LOCALE_TO_LANGUAGE);
      dictionary1.setLocale(dialog.getLocale());
    }
  }

  void subLanguageMenuItem_actionPerformed(ActionEvent e)
  {
    SelectSublanguageDialog dialog = new SelectSublanguageDialog(
      this,
      new Translator(dictionary1),
      false);

    if (dialog.showModal())
    {
      dictionary1.setBinding(multilizer.Dictionary.BIND_LANGUAGE_TO_LOCALE);
      dictionary1.setLocale(dialog.getLocale());
    }
  }

  void translator1_languageChanged(DictionaryEventObject e)
  {
    // Updates the measurement unit

    if (Utils.getMeasurementSystem(dictionary1.getActiveLocale()) == Utils.US_MEASUREMENT)
      unitLabel.setText(translator1.translate("in miles")); //ivlm
    else
      unitLabel.setText(translator1.translate("in kilometres")); //ivlm

    // Update the fine label

    fineLabel.setText(NumberFormat.getCurrencyInstance(
      dictionary1.getActiveLocale()).format(new Integer(100)));

    // Update the date label

    dateLabel.setText(DateFormat.getDateTimeInstance(
      DateFormat.LONG,
      DateFormat.MEDIUM,
      dictionary1.getActiveLocale()).format(new Date()));

    // Update the locale label

    localeLabel.setText(Utils.getLocaleName(dictionary1.getActiveLocale(), dictionary1));
    languageLabel.setText(dictionary1.translate(dictionary1.getLanguageData().englishName));
  }
}

