// Copyrights (C) Innoview Data Technologies Oy 1999

import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import java.util.*;
import java.text.*;
import multilizer.*;

class Currency
{
  public String name;
  public double rate;
  public Locale locale;

  public Currency(String name, double rate, Locale locale)
  {
    this.name = name;
    this.rate = rate;
    this.locale = locale;
  }
}

public class Euro extends Applet implements ActionListener{
  private Vector currencies = new Vector();

  GridLayout gridLayout1 = new GridLayout();
  Panel conversionPanel = new Panel();
  Panel languagePanel = new Panel();
  BorderLayout borderLayout1 = new BorderLayout();
  Panel euroPanel = new Panel();
  Panel currencyPanel = new Panel();
  Panel nationalPanel = new Panel();
  GridLayout gridLayout2 = new GridLayout();
  Panel selectPanel = new Panel();
  Panel buttonPanel = new Panel();
  Label euroLabel = new Label();
  TextField euroField = new TextField();
  GridLayout gridLayout3 = new GridLayout();
  Button euroButton = new Button();
  GridLayout gridLayout4 = new GridLayout();
  GridLayout gridLayout5 = new GridLayout();
  Label currenyLabel = new Label();
  Choice currencyChoice = new Choice();
  Label label1 = new Label();
  FlowLayout flowLayout1 = new FlowLayout();
  FlowLayout flowLayout2 = new FlowLayout();
  Label nationalLabel = new Label();
  TextField nationalField = new TextField();
  Button nationalButton = new Button();
  AppletTranslator translator1 = new AppletTranslator();
  TextDictionary dictionary1 = new TextDictionary();

  public Euro()
  {
  }

  public void addCurrency(String name, double rate, Locale locale)
  {
    currencies.addElement(new Currency(name, rate, locale));
    currencyChoice.add(name);
  }

  public void updateLabels()
  {
    ResourceBundle resources = ResourceBundle.getBundle(
      "java.text.resources.LocaleElements",
      getCurrency(currencyChoice.getSelectedIndex()).locale);
    String[] elements = (String[])resources.getObject("CurrencyElements");

    euroLabel.setText(translator1.translate("Amount") + ", euro (\u20AC)");
    nationalLabel.setText(translator1.translate("Amount") + ", " + elements[0]);
  }

  public Currency getCurrency(int index)
  {
    return (Currency)currencies.elementAt(index);
  }

  public void init()
  {
    try
    {
      jbInit();

      // Adds the EMU countries, currencies and rates

      // Austria
      addCurrency(
        "Austrian schilling", //ivlm
        13.7603,
        new Locale("de", "AT"));

      // Belgium
      addCurrency(
        "Belgian francs", //ivlm
        40.3399,
        new Locale("nl", "BE"));

      // Netherlands
      addCurrency(
        "Dutch guilders", //ivlm
        2.20371,
        new Locale("nl", "NL"));

      // Finland
      addCurrency(
        "Finnish markka", //ivlm
        5.94573,
        new Locale("fi", "FI"));

      // France
      addCurrency(
        "French francs", //ivlm
        6.55957,
        new Locale("fr", "FR"));

      // Germany
      addCurrency(
        "German marks", //ivlm
        1.95583,
        new Locale("de", "DE"));

      // Irland
      addCurrency(
        "Irish punt", //ivlm
        0.787564,
        new Locale("en", "IE"));

      // Italy
      addCurrency(
        "Italian lira", //ivlm
        1936.27,
        new Locale("it", "IT"));

      // Luxembourg
      addCurrency(
        "Luxembourg francs", //ivlm
        40.3399,
        new Locale("fr", "LU"));

      // Portugal
      addCurrency(
        "Portuguese escudo", //ivlm
        200.482,
        new Locale("pt", "PT"));

      // Spain
      addCurrency(
        "Spanish peseta", //ivlm
        166.386,
        new Locale("es", "ES"));

      // Adds the language buttons

      dictionary1.open();
      for (int i = 1; i < dictionary1.getLanguageCount(); i++)
      {
        Language language = dictionary1.getLanguageData(i);
        Button button = new Button(language.nativeName);
        button.addActionListener(this);
        buttonPanel.add(button, null);
      }

      // Translates the applet

      translator1.translate();
    }
    catch (Exception e)
    {
      e.printStackTrace();
    }
  }

  private void jbInit() throws Exception
  {
    conversionPanel.setLayout(borderLayout1);
    this.setBackground(Color.white);
    this.setSize(new Dimension(500, 160));
    gridLayout1.setRows(2);
    gridLayout1.setVgap(5);
    borderLayout1.setVgap(5);
    borderLayout1.setHgap(5);
    nationalPanel.setLayout(gridLayout5);
    currencyPanel.setLayout(gridLayout4);
    euroPanel.setLayout(gridLayout3);
    gridLayout2.setRows(2);
    gridLayout2.setVgap(5);
    gridLayout2.setHgap(5);
    buttonPanel.setLayout(flowLayout2);
    selectPanel.setLayout(flowLayout1);
    euroLabel.setText("Amount, \u20AC (euro)");
    euroField.setText("0");
    euroField.setColumns(10);
    gridLayout3.setRows(3);
    gridLayout3.setVgap(5);
    gridLayout3.setHgap(5);
    euroButton.setLabel("Convert >");
    euroButton.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(ActionEvent e)
      {
        euroButton_actionPerformed(e);
      }
    });
    gridLayout4.setRows(3);
    gridLayout4.setVgap(5);
    gridLayout4.setHgap(5);
    gridLayout5.setRows(3);
    gridLayout5.setVgap(5);
    gridLayout5.setHgap(5);
    currenyLabel.setAlignment(1);
    currenyLabel.setText("Select national currency");
    currencyChoice.addItemListener(new java.awt.event.ItemListener()
    {
      public void itemStateChanged(ItemEvent e)
      {
        currencyChoice_itemStateChanged(e);
      }
    });
    label1.setAlignment(1);
    label1.setText("Select language");
    nationalLabel.setText("Amount");
    nationalField.setText("0");
    nationalField.setColumns(10);
    nationalButton.setLabel("< Convert");
    translator1.setHost(this);
    translator1.addLanguageChangeListener(new multilizer.DictionaryListener()
    {
      public void languageChanged(DictionaryEventObject e)
      {
        translator1_languageChanged(e);
      }
    });
    translator1.addRestrictObjectListener(new multilizer.RestrictObjectListener()
    {
      public void restrictObject(RestrictObjectEventObject e)
      {
        translator1_restrictObject(e);
      }
    });
    dictionary1.setTranslationFileName("dictionary");
    dictionary1.setFileName("dictionary");
    dictionary1.setApplet(this);
    nationalButton.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(ActionEvent e)
      {
        nationalButton_actionPerformed(e);
      }
    });
    languagePanel.setLayout(gridLayout2);
    gridLayout1.setHgap(5);
    this.setLayout(gridLayout1);
    this.setSize(400,300);
    this.add(conversionPanel, null);
    conversionPanel.add(euroPanel, BorderLayout.WEST);
    euroPanel.add(euroLabel, null);
    euroPanel.add(euroField, null);
    euroPanel.add(euroButton, null);
    conversionPanel.add(currencyPanel, BorderLayout.CENTER);
    currencyPanel.add(currenyLabel, null);
    currencyPanel.add(currencyChoice, null);
    conversionPanel.add(nationalPanel, BorderLayout.EAST);
    this.add(languagePanel, null);
    languagePanel.add(selectPanel, null);
    selectPanel.add(label1, null);
    languagePanel.add(buttonPanel, null);
    nationalPanel.add(nationalLabel, null);
    nationalPanel.add(nationalField, null);
    nationalPanel.add(nationalButton, null);
  }

  public String getAppletInfo()
  {
    return "Euro Calculator";
  }

  public void actionPerformed(ActionEvent e)
  {
    // A language change button has been pushed.
    // Changes the language to match the button.

    for (int i = 0; i < buttonPanel.getComponentCount(); i++)
    {
      if (e.getSource() == buttonPanel.getComponent(i))
      {
        dictionary1.setBinding(multilizer.Dictionary.BIND_LOCALE_TO_LANGUAGE);
        dictionary1.setLanguage(i + 1);
        break;
      }
    }
  }

  void calculateNational()
  {
    // Calculates the given Euro amount in the selected national currency

    NumberFormat nf = NumberFormat.getInstance();
    try
    {
      double euro = nf.parse(euroField.getText()).doubleValue();
      double national = euro*getCurrency(currencyChoice.getSelectedIndex()).rate;
      nationalField.setText(nf.format(national));
    }
    catch (Exception ex)
    {
      nationalField.setText("");
    }
  }

  void euroButton_actionPerformed(ActionEvent e)
  {
    calculateNational();
  }

  void nationalButton_actionPerformed(ActionEvent e)
  {
    // Calculates the given national currency amount in Euros

    NumberFormat nf = NumberFormat.getInstance();
    try
    {
      double national = nf.parse(nationalField.getText()).doubleValue();
      double euro = national/getCurrency(currencyChoice.getSelectedIndex()).rate;
      euroField.setText(nf.format(euro));
    }
    catch (Exception ex)
    {
      euroField.setText("");
    }
  }

  void translator1_restrictObject(RestrictObjectEventObject e)
  {
    // Restricts the translation of the language buttons

    for (int i = 0; i < buttonPanel.getComponentCount(); i++)
    {
      if (e.getObject() == buttonPanel.getComponent(i))
      {
        e.setTranslate(false);
        break;
      }
    }
  }

  void currencyChoice_itemStateChanged(ItemEvent e)
  {
    // A new national currency have been selected.
    // Calculates the current Euro amount in this currnecy.

    updateLabels();
    calculateNational();
  }

  void translator1_languageChanged(DictionaryEventObject e)
  {
    updateLabels();
  }
}

