import java.awt.*;
import java.awt.event.*;
import multilizer.*;

// JBuilder users: You can not use the visual frame designer with this project.

public class MainFrame extends Frame implements ActionListener
{
  private List style = new List(4, false);
  private Checkbox bold = new Checkbox("Bold"); //ivlm
  private Checkbox italic = new Checkbox("Italic"); //ivlm
  private TextField size = new TextField();
  private TextField sample = new TextField();
  private Button button = new Button("Language..."); //ivlm
  private Translator translator = new Translator();
  private TextDictionary dictionary = new TextDictionary();

  private void add(
    Component component,
    GridBagLayout layout,
    GridBagConstraints constrainsts,
    int x,
    int y,
    int w,
    int h)
  {
    constrainsts.gridx = x;
    constrainsts.gridy = y;
    constrainsts.gridwidth = w;
    constrainsts.gridheight = h;
    layout.setConstraints(component, constrainsts);
    add(component);
  }

  public MainFrame()
  {
    enableEvents(AWTEvent.WINDOW_EVENT_MASK);

    setTitle("Font Dialog"); //ivlm
    setBackground(SystemColor.control);
    GridBagLayout layout = new GridBagLayout();
    setLayout(layout);

    style.add("Times Roman");
    style.add("Helvetica");
    style.add("Courier");
    style.add("Zapf Dingbats");
    style.add("Dialog");
    style.add("DialogInput");
    style.select(0);

    Label label = new Label("Size: "); //ivlm

    GridBagConstraints constrainsts = new GridBagConstraints();
    constrainsts.fill = GridBagConstraints.BOTH;
    constrainsts.weightx = 20;
    constrainsts.weighty = 100;
    constrainsts.insets = new Insets(2, 2, 2, 2);
    add(style, layout, constrainsts, 0, 0, 1, 3);

    constrainsts.weightx = 100;
    constrainsts.fill = GridBagConstraints.NONE;
    constrainsts.anchor = GridBagConstraints.WEST;
    add(bold, layout, constrainsts, 1, 0, 2, 1);
    add(italic, layout, constrainsts, 1, 1, 2, 1);
    add(label, layout, constrainsts, 1, 2, 1, 1);

    constrainsts.fill = GridBagConstraints.HORIZONTAL;
    add(size, layout, constrainsts, 2, 2, 1, 1);

    constrainsts.anchor = GridBagConstraints.SOUTH;
    constrainsts.weighty = 0;
    add(sample, layout, constrainsts, 0, 3, 2, 1);
    sample.setText("This is a sample text"); //ivlm

    constrainsts.fill = GridBagConstraints.NONE;
    constrainsts.weightx = 0;
    button.addActionListener(this);
    add(button, layout, constrainsts, 2, 3, 1, 1);

    // Center the window

    setSize(300, 180);
    Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
    Dimension frameSize = getSize();
    if (frameSize.height > screenSize.height)
      frameSize.height = screenSize.height;
    if (frameSize.width > screenSize.width)
      frameSize.width = screenSize.width;
    setLocation(
      (screenSize.width - frameSize.width)/2,
      (screenSize.height - frameSize.height)/2);

    // Init dictionary

    dictionary.setFileName("font");

    // Translate the frame

    translator.setHost(this);
    translator.translate();
  }

  protected void processWindowEvent(WindowEvent e)
  {
    super.processWindowEvent(e);
    if (e.getID() == WindowEvent.WINDOW_CLOSING)
      System.exit(0);
  }

  public void actionPerformed(ActionEvent e)
  {
    if (e.getSource() == button)
    {
      // Select a new active language

      SelectLanguageDialog dialog = new SelectLanguageDialog(this, dictionary);

      if (dialog.showModal())
        dictionary.setLanguage(dialog.getLanguage());
    }
  }
}

