import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;
import multilizer.*;

public class MainFrame extends JFrame
{
  JMenuBar jMenuBar1 = new JMenuBar();
  JMenu jMenu1 = new JMenu();
  JMenuItem jMenuItem1 = new JMenuItem();
  JMenuItem jMenuItem2 = new JMenuItem();
  JMenu jMenu2 = new JMenu();
  JMenuItem jMenuItem3 = new JMenuItem();
  JMenuItem jMenuItem5 = new JMenuItem();
  JTabbedPane jTabbedPane1 = new JTabbedPane();
  BorderLayout borderLayout1 = new BorderLayout();
  JMenu jMenu3 = new JMenu();
  JCheckBoxMenuItem windowsMenu = new JCheckBoxMenuItem();
  JCheckBoxMenuItem motifMenu = new JCheckBoxMenuItem();
  JCheckBoxMenuItem metalMenu = new JCheckBoxMenuItem();
  JMenu jMenu4 = new JMenu();
  JMenuItem jMenuItem8 = new JMenuItem();
  JMenuItem jMenuItem9 = new JMenuItem();
  JMenuItem jMenuItem10 = new JMenuItem();
  TestDictionary testDictionary1 = new TestDictionary();
  Translator translator1 = new Translator();
  SwingModule swingModule1 = new SwingModule();

  public MainFrame()
  {
    enableEvents(AWTEvent.WINDOW_EVENT_MASK);

    this.getContentPane().setLayout(borderLayout1);
    this.setSize(new Dimension(518, 300));
    jMenu1.setText("File"); //ivlm
    jMenuItem1.setText("Open..."); //ivlm
    jMenuItem1.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(ActionEvent e)
      {
        jMenuItem1_actionPerformed(e);
      }
    });
    jMenuItem2.setText("Color..."); //ivlm
    jMenuItem2.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(ActionEvent e)
      {
        jMenuItem2_actionPerformed(e);
      }
    });
    jMenu2.setText("Help"); //ivlm
    jMenuItem3.setText("About"); //ivlm
    jMenuItem5.setText("Exit"); //ivlm
    jMenuItem5.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(ActionEvent e)
      {
        jMenuItem5_actionPerformed(e);
      }
    });
    jTabbedPane1.setPreferredSize(new Dimension(5, 200));
    jTabbedPane1.setToolTipText("ToolTip text"); //ivlm
    jMenu3.setText("Look and Feel"); //ivlm
    windowsMenu.setText("Windows");
    windowsMenu.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(ActionEvent e)
      {
        windowsMenu_actionPerformed(e);
      }
    });
    motifMenu.setText("Motif");
    motifMenu.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(ActionEvent e)
      {
        motifMenu_actionPerformed(e);
      }
    });
    metalMenu.setText("Metal");
    metalMenu.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(ActionEvent e)
      {
        metalMenu_actionPerformed(e);
      }
    });
    jMenu4.setText("Dialogs");
    jMenuItem8.setText("Message...");
    jMenuItem9.setText("Custom...");
    jMenuItem10.setText("Language...");
    jMenuItem10.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(ActionEvent e)
      {
        jMenuItem10_actionPerformed(e);
      }
    });
    jMenuItem9.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(ActionEvent e)
      {
        jMenuItem9_actionPerformed(e);
      }
    });
    jMenuItem8.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(ActionEvent e)
      {
        jMenuItem8_actionPerformed(e);
      }
    });
    this.setTitle("Frame Title"); //ivlm
    jMenuBar1.add(jMenu1);
    jMenuBar1.add(jMenu4);
    jMenuBar1.add(jMenu3);
    jMenuBar1.add(jMenu2);
    jMenu1.add(jMenuItem10);
    jMenu1.addSeparator();
    jMenu1.add(jMenuItem5);
    jMenu2.add(jMenuItem3);
    this.setJMenuBar(jMenuBar1);
    this.getContentPane().add(jTabbedPane1, BorderLayout.NORTH);
    jMenu3.add(windowsMenu);
    jMenu3.add(motifMenu);
    jMenu3.add(metalMenu);
    jMenu4.add(jMenuItem1);
    jMenu4.add(jMenuItem2);
    jMenu4.addSeparator();
    jMenu4.add(jMenuItem8);
    jMenu4.add(jMenuItem9);
    jTabbedPane1.addTab("Buttons", null, new ButtonPanel(testDictionary1)); //ivlm
    jTabbedPane1.addTab("List boxes", null, new ListPanel(testDictionary1)); //ivlm
    jTabbedPane1.addTab("Tables", null, new TablePanel(testDictionary1)); //ivlm
    jTabbedPane1.addTab("Trees", null, new TreePanel(testDictionary1)); //ivlm
    metalMenu.setState(true);

    translator1.setHost(this);
    translator1.translate();
  }

  protected void processWindowEvent(WindowEvent e)
  {
    super.processWindowEvent(e);
    if (e.getID() == WindowEvent.WINDOW_CLOSING)
      System.exit(0);
  }

  void jMenuItem5_actionPerformed(ActionEvent e)
  {
    System.exit(0);
  }

  void jMenuItem8_actionPerformed(ActionEvent e)
  {
    new MOptionPane(testDictionary1).showMessageDialog(this, "Test");
  }

  void jMenuItem9_actionPerformed(ActionEvent e)
  {
    String[] buttons = {"One", "Two", "Three", "Four"};

    new MOptionPane(testDictionary1).showOptionDialog(
      this,
      "Test",
      "Title",
      JOptionPane.YES_NO_OPTION,
      JOptionPane.INFORMATION_MESSAGE,
      null,
      buttons,
      null);
  }

  void jMenuItem1_actionPerformed(ActionEvent e)
  {
    // Use multilizer.FileChooser instead of JFileChooser

    FileChooser chooser = new FileChooser();

    chooser.setDialogTitle("Open"); //ivlm
    if (chooser.showOpenDialog(this) == JFileChooser.APPROVE_OPTION)
    {
    }
  }

  void jMenuItem2_actionPerformed(ActionEvent e)
  {
/*
    // Use multilizer.ColorChooser instead of JColorChooser

    ColorChooser chooser = new ColorChooser();

    if (chooser.showDialog(this, "Color", Color.white) != null) //ivlm
    {
    }
*/
  }

  void jMenuItem10_actionPerformed(ActionEvent e)
  {
    int language = SelectLanguageDialog.select(
      this,
      new Translator(testDictionary1),
      false);

    if (language >= 0)
      testDictionary1.setLanguage(language);
  }

  void setLookAndFeel(int type)
  {
    windowsMenu.setState(false);
    motifMenu.setState(false);
    metalMenu.setState(false);

    try
    {
      switch (type)
      {
        case 0:
          UIManager.setLookAndFeel(new com.sun.java.swing.plaf.windows.WindowsLookAndFeel());
          windowsMenu.setState(true);
          break;

        case 1:
          UIManager.setLookAndFeel(new com.sun.java.swing.plaf.motif.MotifLookAndFeel());
          motifMenu.setState(true);
          break;

        case 2:
          UIManager.setLookAndFeel(new javax.swing.plaf.metal.MetalLookAndFeel());
          metalMenu.setState(true);
          break;
      }
      SwingUtilities.updateComponentTreeUI(this);
    }
    catch (Exception ex)
    {
    }
  }

  void windowsMenu_actionPerformed(ActionEvent e)
  {
    setLookAndFeel(0);
  }

  void motifMenu_actionPerformed(ActionEvent e)
  {
    setLookAndFeel(1);
  }

  void metalMenu_actionPerformed(ActionEvent e)
  {
    setLookAndFeel(2);
  }
}

